import win32serviceutil
import pythoncom
import win32service
import win32event
import servicemanager
import socket
import sys

class ArtixUploadSoapService(win32serviceutil.ServiceFramework):
    _svc_name_ = "ArtixUploadSoapService"
    _svc_display_name_ = "ArtixUploadSoapService"

    def __init__(self,args):
        win32serviceutil.ServiceFramework.__init__(self,args)
        self.hWaitStop = win32event.CreateEvent(None,0,0,None)
        socket.setdefaulttimeout(60)

    def SvcStop(self):
        self.ReportServiceStatus(win32service.SERVICE_STOP_PENDING)
        win32event.SetEvent(self.hWaitStop)
        self.ReportServiceStatus(win32service.SERVICE_STOPPED)

    def SvcDoRun(self):
        servicemanager.LogMsg(servicemanager.EVENTLOG_INFORMATION_TYPE,
                              servicemanager.PYS_SERVICE_STARTED,
                              (self._svc_name_,''))
        self.main()

    def main(self):

        if sys.path[-1].find('fam') != -1:
            myPath = sys.path[-1]
            sys.path[-1] = sys.path[0]
            sys.path[0] = myPath

        import startUploadSoapService
        startUploadSoapService.main()

if __name__ == '__main__':
    win32serviceutil.HandleCommandLine(ArtixUploadSoapService)